package com.esignlive.guidance.forum;

import java.util.ArrayList;
import java.util.List;

import com.silanis.esl.sdk.Document;
import com.silanis.esl.sdk.DocumentPackage;
import com.silanis.esl.sdk.EslClient;
import com.silanis.esl.sdk.Page;
import com.silanis.esl.sdk.PageRequest;

public class _21_03_03_get_packages_by_document_name {
	private final String API_KEY = "your_api_key";
	private final String API_URL = "https://sandbox.esignlive.com/api";
	private List<PkgsContainDocNameVo> documentNames = new ArrayList<PkgsContainDocNameVo>(){{
		add(new PkgsContainDocNameVo("Document1"));
		add(new PkgsContainDocNameVo("Document2"));
	}};
	
	

	public static void main(String[] args) {
		new _21_03_03_get_packages_by_document_name().execute();
	}
	
	public void execute() {
		EslClient eslClient = new EslClient(API_KEY, API_URL);
		
		//sent, completed, draft, archived, trashed
		getAllPackagesPerStatus("sent",eslClient);
		getAllPackagesPerStatus("completed",eslClient);
		getAllPackagesPerStatus("draft",eslClient);
		getAllPackagesPerStatus("archived",eslClient);
		getAllPackagesPerStatus("trashed",eslClient);
		
		for (PkgsContainDocNameVo pkgsContainDocNameVo : documentNames) {
			System.out.println("Document Name: " + pkgsContainDocNameVo.documentName + "; Package IDs: " + pkgsContainDocNameVo.packageIds);
		}
		
	}
	
	private void getAllPackagesPerStatus(String status, EslClient eslClient){
		Page<DocumentPackage> packages;
		int index = 1;
		do {
			packages = eslClient.getPackageService().getPackages(status, new PageRequest(index, 100));	
			index += 100;
			
			for (DocumentPackage documentPackage : packages.getResults()) {
				for (Document document : documentPackage.getDocuments()) {
					for (PkgsContainDocNameVo pkgsContainDocNameVo : documentNames) {
						if(document.getName().equals(pkgsContainDocNameVo.documentName)) {
							pkgsContainDocNameVo.packageIds.add(documentPackage.getId().getId());
						}
					}
				}
			}
		}while(packages.hasNextPage());
	}
	
	private class PkgsContainDocNameVo {
		public String documentName;
		public List<String> packageIds = new ArrayList<String>();
		public PkgsContainDocNameVo(String documentName) {
			this.documentName = documentName;
		}
	}

}